package com.net
{
	import flash.events.*;
	import flash.net.*;

	internal class AbstractLoader implements IEventDispatcher
	{
		public var url: String;
		
		public function AbstractLoader(){}
		
		protected var loader: URLStream;
		public function load(): void
		{
			if( this.url == null || this.url == "" )
			{
				this.loadFailIO( new IOErrorEvent( IOErrorEvent.IO_ERROR ) );
				return;
			}
			
			this.loader = new URLStream();
			this.loader.addEventListener( Event.COMPLETE, loadComplete );
			this.loader.addEventListener( IOErrorEvent.IO_ERROR, loadFailIO );
			this.loader.addEventListener( SecurityErrorEvent.SECURITY_ERROR, loadFailSecurity );
			this.loader.addEventListener( ProgressEvent.PROGRESS, loadProgress );
			this.loader.load( new URLRequest( this.url ) );
		}
		
		protected function loadFailIO( e: Event ): void
		{
			throw new Error( "AbstractLoader.loadFailIO must be overriden." );
		}
		
		protected function loadFailSecurity( e: Event ): void
		{
			throw new Error( "AbstractLoader.loadFailSecurity must be overriden." );
		}
		
		protected function loadProgress( e: ProgressEvent ): void
		{
			this.dispatchEvent( e.clone() );
		}
		
		protected function loadComplete( e: Event ): void
		{
			throw new Error( "AbstractLoader.loadComplete must be overriden." );
		}
		
		include "IEventDispatcher.source";
	}
}